use crate::prelude::*;

use std::os::raw::c_void;

#[repr(C)]
pub struct VkBaseInStructure {
    pub sType: VkStructureType,
    pub pNext: *const c_void,
}

impl VkBaseInStructure {
    /// https://raw.githubusercontent.com/MaikKlein/ash/master/ash/src/vk.rs
    pub(crate) unsafe fn ptr_chain_iter(
        me: *mut Self,
    ) -> impl Iterator<Item = *mut VkBaseInStructure> {
        let ptr = me as *mut VkBaseInStructure;
        (0..).scan(ptr, |p_ptr, _| {
            if p_ptr.is_null() {
                return None;
            }
            let n_ptr = (**p_ptr).pNext as *mut VkBaseInStructure;
            let old = *p_ptr;
            *p_ptr = n_ptr;
            Some(old)
        })
    }
}
