use crate::prelude::*;

use std::os::raw::c_void;
use std::ptr;

#[repr(C)]
#[derive(Copy, Clone)]
pub struct VkAccelerationStructureGeometryAabbsDataKHR {
    pub sType: VkStructureType,
    pub pNext: *const c_void,
    pub data: VkDeviceOrHostAddressConstKHR,
    pub stride: VkDeviceSize,
}

impl VkAccelerationStructureGeometryAabbsDataKHR {
    pub fn new(data: VkDeviceOrHostAddressConstKHR, stride: VkDeviceSize) -> Self {
        VkAccelerationStructureGeometryAabbsDataKHR {
            sType: VK_STRUCTURE_TYPE_ACCELERATION_STRUCTURE_GEOMETRY_AABBS_DATA_KHR,
            pNext: ptr::null(),
            data,
            stride,
        }
    }
}
