use crate::prelude::*;

use std::os::raw::c_void;
use std::ptr;

#[repr(C)]
#[derive(Debug)]
pub struct VkPhysicalDeviceAccelerationStructurePropertiesKHR {
    pub sType: VkStructureType,
    pub pNext: *mut c_void,
    pub maxGeometryCount: u64,
    pub maxInstanceCount: u64,
    pub maxPrimitiveCount: u64,
    pub maxPerStageDescriptorAccelerationStructures: u32,
    pub maxPerStageDescriptorUpdateAfterBindAccelerationStructures: u32,
    pub maxDescriptorSetAccelerationStructures: u32,
    pub maxDescriptorSetUpdateAfterBindAccelerationStructures: u32,
    pub minAccelerationStructureScratchOffsetAlignment: u32,
}

impl Default for VkPhysicalDeviceAccelerationStructurePropertiesKHR {
    fn default() -> Self {
        VkPhysicalDeviceAccelerationStructurePropertiesKHR {
            sType: VK_STRUCTURE_TYPE_PHYSICAL_DEVICE_ACCELERATION_STRUCTURE_PROPERTIES_KHR,
            pNext: ptr::null_mut(),
            maxGeometryCount: 0,
            maxInstanceCount: 0,
            maxPrimitiveCount: 0,
            maxPerStageDescriptorAccelerationStructures: 0,
            maxPerStageDescriptorUpdateAfterBindAccelerationStructures: 0,
            maxDescriptorSetAccelerationStructures: 0,
            maxDescriptorSetUpdateAfterBindAccelerationStructures: 0,
            minAccelerationStructureScratchOffsetAlignment: 0,
        }
    }
}

unsafe impl Sync for VkPhysicalDeviceAccelerationStructurePropertiesKHR {}
unsafe impl Send for VkPhysicalDeviceAccelerationStructurePropertiesKHR {}
